scala.tools.nsc.backend.icode.GenICode.ICodePhase

# DuplicateLabels

#### class DuplicateLabels extends Global.Transformer

Tree transformer that duplicates code and at the same time creates fresh symbols for existing labels. Since labels may be used before they are defined (forward jumps), all labels found are mapped to fresh symbols. References to the same label (use or definition) will remain consistent after this transformation (both the use and the definition of some label l will be mapped to the same label l').

Note: If the tree fragment passed to the duplicator contains unbound label names, the bind to the outer labeldef will be lost! That's because a use of an unbound label l will be transformed to l', and the corresponding label def, being outside the scope of this transformation, will not be updated.

All LabelDefs are entered into the context label map, since it makes no sense to delay it any more: they will be used at some point.

Source
  GenICode.scala

Linear Supertypes
Global.Transformer, Global.Transformer, AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. DuplicateLabels
2. Transformer
3. Transformer
4. AnyRef
5. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new DuplicateLabels(boundLabels: Set[Global.Symbol])

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from DuplicateLabels to any2stringadd[DuplicateLabels] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (DuplicateLabels, B)

   Implicit information
     This member is added by an implicit conversion from DuplicateLabels to ArrowAssoc[DuplicateLabels] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### def apply(ctx: Context, t: Global.Tree): Global.Tree

7. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

8. #### def atOwner[A](owner: Global.Symbol)(trans: ⇒ A): A

   Definition Classes
     Transformer

9. #### def clone(): AnyRef

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )

10. #### var ctx: Context

11. #### def currentClass: Global.Symbol

    Attributes
      protected
    Definition Classes
      Transformer

12. #### def currentMethod: Global.Symbol

    Attributes
      protected
    Definition Classes
      Transformer

13. #### var currentOwner: Global.Symbol

    Attributes
      protected[scala]
    Definition Classes
      Transformer

14. #### def ensuring(cond: (DuplicateLabels) ⇒ Boolean, msg: ⇒ Any): DuplicateLabels

    Implicit information
      This member is added by an implicit conversion from DuplicateLabels to Ensuring[DuplicateLabels] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### def ensuring(cond: (DuplicateLabels) ⇒ Boolean): DuplicateLabels

    Implicit information
      This member is added by an implicit conversion from DuplicateLabels to Ensuring[DuplicateLabels] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### def ensuring(cond: Boolean, msg: ⇒ Any): DuplicateLabels

    Implicit information
      This member is added by an implicit conversion from DuplicateLabels to Ensuring[DuplicateLabels] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### def ensuring(cond: Boolean): DuplicateLabels

    Implicit information
      This member is added by an implicit conversion from DuplicateLabels to Ensuring[DuplicateLabels] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

19. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

20. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

21. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from DuplicateLabels to StringFormat[DuplicateLabels] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

22. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

23. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

24. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

25. #### val labels: HashMap[Global.Symbol, Global.Symbol]

26. #### var method: Global.Symbol

27. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

28. #### final def notify(): Unit

    Definition Classes
      AnyRef

29. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

30. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

31. #### def toString(): String

    Definition Classes
      AnyRef → Any

32. #### def transform(t: Global.Tree): Global.Tree

    Definition Classes
      DuplicateLabels → Transformer

33. #### def transformCaseDefs(trees: List[Global.CaseDef]): List[Global.CaseDef]

    Definition Classes
      Transformer

34. #### def transformIdents(trees: List[Global.Ident]): List[Global.Ident]

    Definition Classes
      Transformer

35. #### def transformMemberDefs(trees: List[Global.MemberDef]): List[Global.MemberDef]

    Definition Classes
      Transformer

36. #### def transformModifiers(mods: Global.Modifiers): Global.Modifiers

    Definition Classes
      Transformer

37. #### def transformStats(stats: List[Global.Tree], exprOwner: Global.Symbol): List[Global.Tree]

    Definition Classes
      Transformer

38. #### def transformTemplate(tree: Global.Template): Global.Template

    Definition Classes
      Transformer

39. #### def transformTrees(trees: List[Global.Tree]): List[Global.Tree]

    Definition Classes
      Transformer

40. #### def transformTypeDefs(trees: List[Global.TypeDef]): List[Global.TypeDef]

    Definition Classes
      Transformer

41. #### def transformUnit(unit: Global.CompilationUnit): Unit

    Definition Classes
      Transformer

42. #### def transformValDef(tree: Global.ValDef): Global.ValDef

    Definition Classes
      Transformer

43. #### def transformValDefs(trees: List[Global.ValDef]): List[Global.ValDef]

    Definition Classes
      Transformer

44. #### def transformValDefss(treess: List[List[Global.ValDef]]): List[List[Global.ValDef]]

    Definition Classes
      Transformer

45. #### val treeCopy: Global.TreeCopier

    Definition Classes
      Transformer

46. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

47. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

48. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

49. #### def →[B](y: B): (DuplicateLabels, B)

    Implicit information
      This member is added by an implicit conversion from DuplicateLabels to ArrowAssoc[DuplicateLabels] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from Global.Transformer

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from DuplicateLabels to any2stringadd[DuplicateLabels]

### Inherited by implicit conversion StringFormat from DuplicateLabels to StringFormat[DuplicateLabels]

### Inherited by implicit conversion Ensuring from DuplicateLabels to Ensuring[DuplicateLabels]

### Inherited by implicit conversion ArrowAssoc from DuplicateLabels to ArrowAssoc[DuplicateLabels]

### Ungrouped